'*********************************************************************
'/* COPYRIGHTS:                                                      */
'/*                                                                  */
'/*   This module contains code made available by IBM Corporation on */
'/* an AS IS basis.  Any one receiving the module is  considered  to */
'/* be  licensed under IBM copyrights to use the IBM-provided source */
'/* code in any way he or  she  deems  fit,  including  copying  it, */
'/* compiling  it,  modifying  it,  and  redistributing  it, with or */
'/* without modifications.  No license  under  any  IBM  patents  or */
'/* patent  applications  is  to  be  implied  from  this  copyright */
'/* license.                                                         */
'/*                                                                  */
'/*   A user of the module should understand that IBM cannot provide */
'/* technical support for the module and will not be responsible for */
'/* any consequences of use of the program.                          */
'/*                                                                  */
'/*   Any notice,  including this one, are not to  be  removed  from */
'/* the module with out the prior written consent of IBM.            */
'/*                                                                  */
'*********************************************************************
'
'This examples uses ADO and Windows scripting host (WSH).  WSH is included
'with Windows 2000 and 98.  It can be downloaded from www.microsoft.com/scripting
'for both Windows 95 and NT.
'
'cscript [host options...] [script name] [script options and parameters
'   cscript //B  "C:\rfrompcx.vbs"  /MYLIB /MYFILE /C:\file.txt
'
'
'[ScriptFile]
'Path=C:\WINNT\Samples\WSH\showprop.vbs
'[Options]
'Timeout = 0
'DisplayLogo = 0
'BatchMode = 1

   Const ForReading = 1

   Dim cn 		'As New ADODB.Connection
   Dim cmd 		'As New ADODB.Command
   Dim md 		'As ADODB.Recordset
   Dim NumCols
   Dim FSO 		'As Scripting.FileSystemObject
   Dim hFile 		'As Scripting.TextStream

   Dim Lib 		'As String
   Dim TableName 	'As String
   Dim PCFileName 	'As String
   Dim S 		'As String
   Dim I 		'As Long
   
   
   'Read in parms
   Dim objArgs
   Set objArgs = WScript.Arguments
   For I = 0 To objArgs.Count - 1       
      WScript.Echo objArgs(I)
   Next
   Lib =Trim( Mid(objArgs(0), 2) )
   Tablename = Trim(Mid(objArgs(1), 2) )
   PCFileName = Trim(Mid(objArgs(2), 2) )
   
   'Connect
   Set cn = CreateObject("ADODB.Connection")
   cn.Open "DSN=RCHAS194;"  ',"user", "pwd"
   
   'Get some basic metadata on the AS/400 file.
   ' Could use Set md = cn.OpenSchema(adSchemaColumns, Array(vEmpty, Lib, FileName))
   Set md = cn.Execute( _
            "SELECT COLUMN_COUNT from QSYS2.SYSTABLES WHERE TABLE_NAME = '" & _
               Trim(TableName) & "' AND TABLE_OWNER = '" & Trim(Lib) & "' ")
   If md.EOF Then
      'File does not exist.
      
   End If
   NumCols = md(0).Value
   
   'Clear file if desired
   cn.Execute "DELETE FROM " & Lib & "." & TableName
      
   'Prepare the insert
   Set cmd = CreateObject("ADODB.Command")
   cmd.Prepared = True
   Set cmd.ActiveConnection = cn
   S = "INSERT INTO " & Lib & "." & TableName & " VALUES ("
   For I = 1 To NumCols - 1
      S = S & "?, "
   Next 
   S = S & " ? ) "
   cmd.CommandText = S
   cmd.Parameters.Refresh     'Prepare the statement
   
   'Open the PC file
   Set FSO = CreateObject("Scripting.FileSystemObject")
   Set hFile = FSO.OpenTextFile(PCFileName, ForReading)
    
   'Read in the file and insert the row (this assumes CSV)
   Dim RowData
   Do While Not hFile.AtEndOfStream
      LineNum = LineNum + 1
      'Read on line
      S = hFile.ReadLine
      
      'Parse the data
      'This will handle a simple CSV with no double quoted strings or
      'embedded commas.  More elaborate parsing may be needed.
      RowData = Split(S, ",")
      If UBound(RowData) - LBound(RowData) + 1 <> NumCols Then
         'Report error for column mismatch
      End If
      
      '"Cast" the data to the correct type.
      'You can use variant for most types.  If needed you
      'can add special handling for each type below. Special handling
      'may be needed for date/time/timestamp and binary(65535) fields.
      For I = 0 To NumCols - 1
         Select Case cmd.Parameters(I).Type
'            Case adChar, adVarChar, adLongVarChar
'            Case adInteger, adSmallInt
'            Case adDouble, adSingle
'            Case adNumeric, adDecimal
'            Case adBigInt
'            Case adVarBinary, adBinary
'            Case adDBDate
'            Case adDBTime
'            Case adDBTimeStamp
           Case Else
               cmd.Parameters(I).Value = RowData(I)
         End Select
      Next    'For I = 0 To NumCols - 1
      cmd.Execute
   Loop     'While Not hFile.AtEndOfStream
   WScript.Echo "Successfully inserted " & LineNum  & " rows of data."
   
   
   